#include "StdAfx.h"
#include "AlignLayoutManager.h"

REGISTER_SCRIPTLETCONTAINER_CREATOR(_T("AlignLayout"), AlignLayoutManager);
AlignLayoutManager::AlignLayoutManager(void)
{
}

AlignLayoutManager::~AlignLayoutManager(void)
{
}
void AlignLayoutManager::LayoutContainer(CContainer* pParent)
{
	CRect rcClient;
	pParent->GetDrawingBounds(&rcClient);

	CAtlList<CComponent*> lstChild;
	pParent->GetChildList(lstChild);
	POSITION pos = lstChild.GetHeadPosition();
	while (pos)
	{
		CComponent* pChild = lstChild.GetNext(pos);
		if (pChild->IsVisible() == TRUE)
		{
			LayoutComponent(pChild, rcClient);
		}
	}
}
void AlignLayoutManager::LayoutComponent(CComponent* child, CRect& rcClient)
{
	HorizonAlignment::eHorizonAlignment horizontalAlignment = child->GetHorizontalAligment();
	VerticalAlignment::eVerticalAlignment verticalAlignment = child->GetVerticalAlignment();

	CSize preferredSize(0);
	if (FALSE == child->GetPreferredSize(&preferredSize))
	{
		preferredSize.SetSize(0, 0);
		horizontalAlignment = HorizonAlignment::Stretch;
		verticalAlignment = VerticalAlignment::Stretch;
	}
	
	CRect rcMargin(0, 0, 0, 0);
	child->GetMargin(&rcMargin);
	CRect rcChild(0, 0, 0, 0);
		
	if (verticalAlignment == VerticalAlignment::Stretch)
	{
		rcChild.top = rcMargin.top;
		rcChild.bottom = rcClient.Height() - rcMargin.bottom;
	}
	else if (verticalAlignment == VerticalAlignment::Center)
	{
		rcChild.top = (rcClient.Height()-preferredSize.cy)/2 + rcMargin.top - rcMargin.bottom;
		rcChild.bottom = rcChild.top + preferredSize.cy;
	}
	else if (verticalAlignment == VerticalAlignment::Bottom)
	{
		rcChild.top = rcClient.Height() - preferredSize.cy - rcMargin.bottom;
		rcChild.bottom = rcChild.top + preferredSize.cy;
	}
	else
	{
		rcChild.top = rcMargin.top;
		rcChild.bottom = rcChild.top + preferredSize.cy;
	}
	
	if (horizontalAlignment == HorizonAlignment::Stretch)
	{
		rcChild.left = rcMargin.left;
		rcChild.right = rcClient.Width() - rcMargin.right;
	}
	else if (horizontalAlignment == HorizonAlignment::Center)
	{
		rcChild.left = (rcClient.Width() - preferredSize.cx)/2 + rcMargin.left - rcMargin.right;
		rcChild.right = rcChild.left + preferredSize.cx;
	}
	else if (horizontalAlignment == HorizonAlignment::Right)
	{
		rcChild.left = rcClient.Width() - preferredSize.cx - rcMargin.right;
		rcChild.right = rcChild.left + preferredSize.cx;
	}
	else
	{
		rcChild.left = rcMargin.left;
		rcChild.right = rcChild.left + preferredSize.cx;
	}
	
	child->SetActualBound(rcChild.left, rcChild.top, rcChild.Width(), rcChild.Height());
}